unit Setting;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, Vcl.ComCtrls;

const
  FORM_WIDTH_SET       = 680;
  FORM_HEIGHT_SET      = 340;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

type
  TFormSetting = class(TForm)
    Panel1: TPanel;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    ComboBox1: TComboBox;
    RadioGroup1: TRadioGroup;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Label4: TLabel;
    TabSheet3: TTabSheet;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrFormParent: String;

  public
    { Public 錾 }

  end;

var
  FormSetting: TFormSetting;

implementation

{$R *.dfm}

uses CsvText;

procedure TFormSetting.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSetting.FormClose(Sender: TObject; var Action: TCloseAction);
begin
;
end;

procedure TFormSetting.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormSetting.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
begin
  //
  IntFormShiftX  := 0;
  IntFormShiftY  := 0;

  //m
  sStr1 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
  IniFile := TIniFile.Create (sStr1);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormSetting', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSetting', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSetting', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSetting', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSetting', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  sStr1 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
  IniFile := TIniFile.Create (sStr1);
  //Ǎ
  Edit1.Text             := IniFile.ReadString ('Editor',      'LineFeed',   '');
  Edit2.Text             := IniFile.ReadString ('Editor',      'Separater',  '');
  ComboBox1.ItemIndex    := IniFile.ReadInteger('LineWidth',   'Index',         5);
  RadioGroup1.ItemIndex  := IniFile.ReadInteger('LineNumber',  'LineZero',      1);
  RadioGroup2.ItemIndex  := IniFile.ReadInteger('TabEnabled',  'Index',         0);
  RadioGroup3.ItemIndex  := IniFile.ReadInteger('TabDisabled', 'Index',         0);
  StrFormParent          := IniFile.ReadString ('FormSetting', 'Parent',     PARENT_LINE_NUMBER);
  //j
  IniFile.Free;

  //ݒ
  if StrFormParent = PARENT_LINE_NUMBER then
  begin
    TabSheet1.TabVisible := TRUE;
    TabSheet2.TabVisible := FALSE;
    TabSheet3.TabVisible := FALSE;
    PageControl1.ActivePageIndex := 0;
  end;
  if StrFormParent = PARENT_ITEM_LF then
  begin
    TabSheet1.TabVisible := FALSE;
    TabSheet2.TabVisible := TRUE;
    TabSheet3.TabVisible := FALSE;
    PageControl1.ActivePageIndex := 1;
  end;
  if StrFormParent = PARENT_SHOW_MERY then
  begin
    TabSheet1.TabVisible := FALSE;
    TabSheet2.TabVisible := FALSE;
    TabSheet3.TabVisible := TRUE;
    PageControl1.ActivePageIndex := 2;
  end;
end;

procedure TFormSetting.FormDestroy(Sender: TObject);
var
  sStr1: String;
  IniFile: TIniFile;
begin
  //m
  sStr1 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
  IniFile := TIniFile.Create (sStr1);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSetting', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSetting', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSetting', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSetting', 'Left',   FormSetting.Left);
    IniFile.WriteInteger('FormSetting', 'Top',    FormSetting.Top);
    IniFile.WriteInteger('FormSetting', 'Width',  FormSetting.Width);
    IniFile.WriteInteger('FormSetting', 'Height', FormSetting.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormSetting.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end
  //
  else
  begin
    ;
  end;
end;

procedure TFormSetting.FormResize(Sender: TObject);
begin
;
end;

procedure TFormSetting.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSetting.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSetting.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSetting.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSetting.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSetting.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;
end;
procedure TFormSetting.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
begin
  if StrFormParent = PARENT_LINE_NUMBER then
  begin
    //m
    sStr1 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
    IniFile := TIniFile.Create (sStr1);
    //ۑ
    IniFile.WriteString ('LineWidth',   'Text',       ComboBox1.Text);
    IniFile.WriteInteger('LineWidth',   'Index',      ComboBox1.ItemIndex);
    IniFile.WriteInteger('LineNumber',  'LineZero',   RadioGroup1.ItemIndex);
    //j
    IniFile.Free;
  end;

  if StrFormParent = PARENT_ITEM_LF then
  begin
    if Edit2.Text = '' then
    begin
      showmessage('ؕݒ肳Ă܂');
      Exit;
    end;

    //m
    sStr1 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
    IniFile := TIniFile.Create (sStr1);
    //ۑ
    IniFile.WriteString ('Editor',     'LineFeed',   Edit1.Text);
    IniFile.WriteString ('Editor',     'Separater',  Edit2.Text);
    //j
    IniFile.Free;
  end;

  if StrFormParent = PARENT_SHOW_MERY then
  begin
    //m
    sStr1 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
    IniFile := TIniFile.Create (sStr1);
    //ۑ
    IniFile.WriteInteger('TabEnabled',  'Index',      RadioGroup2.ItemIndex);
    IniFile.WriteInteger('TabDisabled', 'Index',      RadioGroup3.ItemIndex);
    //j
    IniFile.Free;
  end;

  //I
  ModalResult := mrOK;
end;

procedure TFormSetting.Button1Click(Sender: TObject);
begin
  Edit1.Text := '<Ret>';
end;

procedure TFormSetting.Button2Click(Sender: TObject);
begin
  Edit1.Text := '<Lf>';
end;

procedure TFormSetting.Button3Click(Sender: TObject);
begin
  Edit1.Text := '';
end;

procedure TFormSetting.Button4Click(Sender: TObject);
begin
  Edit1.Text := '';
end;

procedure TFormSetting.Button5Click(Sender: TObject);
begin
  Edit1.Text := '';
end;

procedure TFormSetting.Button6Click(Sender: TObject);
begin
  Edit2.Text := '';
end;

procedure TFormSetting.Button7Click(Sender: TObject);
begin
  Edit2.Text := '';
end;

procedure TFormSetting.Button8Click(Sender: TObject);
begin
  Edit2.Text := '';
end;

procedure TFormSetting.Button9Click(Sender: TObject);
begin
  Edit2.Text := '';
end;

procedure TFormSetting.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

end.
